/**
 * The famous swap problem, a method changing order of parameter values
 *
 * if (before call) x = 1, y = 2 then after call x = 2, y = 1 or ????
 *
 *
 * @author hajo
 */
public class Swap {

    public static void main(String[] args) {
        int x = 1;
        int y = 2;
        swap(x,y);
        System.out.println("x=" + x + " y=" + y);
        swap2(x,y);
        System.out.println("x=" + x + " y=" + y);
        
        // Single element array
        int[] xArr = {1};
        int[] yArr = {2};
        swap3(xArr, yArr);
        System.out.println("x=" + xArr[0] + " y=" + yArr[0]);
    }

    public static void swap(int x, int y) {
        int tmp = x;
        x = y;
        y = tmp;
    }

    public static void swap2(Integer i, Integer j) {
        Integer tmp = i;
        i = j;
        j = tmp;
    }

    public static void swap3(int[] i, int[] j) {
        int tmp = i[0];
        i[0] = j[0];
        j[0] = tmp;
    }
}
